<?php

/**
 * Description of SP
 *
 * @author ade
 */
class BHelp {

    public static function EvalMixExp($amount, $mixExp, $sign) {
        $amt = $amount;
        $retval = 0;
        $tmp;
        $token;
        $tokens = array();

        self::Tokenize($mixExp, "+", $tokens);        

        try {
            if (count($tokens) > 0) {
                for ($i = 0; $i < count($tokens); $i++) {
                    $token = $tokens[$i];
                    if (strpos($token, '%') > 0) {
                        $tmp = $amt * ((substr($token, 0, strlen($token) - 1)) / (100));
                    } else {
                        $tmp = $token;
                    }

                    if ($sign == '-') {
                        $amt = $amt + self::negate($tmp);
                    } else {
                        $amt = $amt + $tmp;
                    }

                    $retval = $retval + $tmp;
                }
            }
        } catch (Exception $e) {
            $retval = 0;
        }

        return $retval;
    }

    public static function Tokenize($txt, $delimeter, &$tokens) {
        $tmp;
        $token;
        $i;
        $result = false;

        $tmp = $txt;
        
        try {
            while ($tmp != null) {
                $i = strpos($tmp, $delimeter);
                
                if (($i > 0 ) // got token
                        || (($i == 0) && (strlen($tmp) > 0)) // last token
                ) {
                    if ($i == 0) {                   // last token
                        $token = $tmp;
                        $tmp = null;
                    } else {
                        $token = substr($tmp, 0, $i);
                        $tmp = substr($tmp, $i + 1, strlen($tmp));
                    }

                    $tokens[] = $token;
                }
            }
        } catch (Exception $ex) {
            
        }
    }

    public static function EvalDiscExp($price, $discExp) {
        return (self::EvalMixExp($price, $discExp, '-'));
    }

    public static function EvalTaxExp($price, $taxExp) {
        return (self::EvalMixExp($price, $taxExp, '+'));
    }

    public static function negate($amt) {
        return $amt * -1;
    }

}

?>
