<h1>Order</h1>

<div class="form">

<?php $form=$this->beginWidget('CActiveForm', array(
	'id'=>'bill-form',
	'enableClientValidation'=>true,
	'clientOptions'=>array(
		'validateOnSubmit'=>true,
	),
)); ?>

	<p class="note">Fields with <span class="required">*</span> are required.</p>

	<?php echo $form->errorSummary($model); ?>

	<div class="row">
		<?php echo $form->labelEx($model,'bpid'); ?>
		<?php echo $form->textField($model,'bpid', array('value'=>'CASH')); ?>
		<?php echo $form->error($model,'bpid'); ?>
	</div>

	<div class="row">
		<?php echo $form->labelEx($model,'billdate'); ?>
		<?php echo $form->textField($model,'billdate', array('value'=>date('Y-m-d'))); ?>
		<?php echo $form->error($model,'billdate'); ?>
	</div>
        
        <div class="row">
		<?php echo $form->labelEx($model,'pax'); ?>
		<?php echo $form->textField($model,'pax', array('value'=>'2')); ?>
		<?php echo $form->error($model,'pax'); ?>
	</div>
        
        <div class="row">
		<?php echo $form->labelEx($model,'hostid'); ?>
		<?php echo $form->textField($model,'hostid', array('value'=>'1')); ?>
		<?php echo $form->error($model,'hostid'); ?>
	</div>
        
        <div class="row">
		<?php echo $form->labelEx($model,'billtype'); ?>
		<?php echo $form->textField($model,'billtype', array('value'=>'DI')); ?>
		<?php echo $form->error($model,'billtype'); ?>
	</div>
        
        <div class="row">
		<?php echo $form->labelEx($model,'arrivetime'); ?>
		<?php echo $form->textField($model,'arrivetime', array('value'=>date('H:i:s'))); ?>
		<?php echo $form->error($model,'arrivetime'); ?>
	</div>
        
        <div class="row">
		<?php echo $form->labelEx($model,'srepid'); ?>
		<?php echo $form->textField($model,'srepid', array('value'=>'0001')); ?>
		<?php echo $form->error($model,'srepid'); ?>
	</div>

	<div class="row buttons">
		<?php echo CHtml::submitButton('Submit'); ?>
	</div>

<?php $this->endWidget(); ?>

</div><!-- form -->
